
/*****************************************************************************************
*
*  Vinhthuy Phan
*  pointloc.h
*  06/25/97
*
*****************************************************************************************/


#ifndef pointloc_h
#define pointloc_h

#include <time.h>
#include <ctype.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "predict.h"

#ifndef bool
#define bool int
#endif


/*****************************************************************************************
*  
*  Global variables used for PointLocation
*
*****************************************************************************************/

VERTEX_TYPE*    pgVERTICES;
EDGE_TYPE*      pgEDGES;
TRIANGLE_TYPE*  pgTRIANGLES;
long NUM_OF_VET[3];
long NUM_OF_INTERSECTED_EDGES = 0;  /** keeping track of the # of crossed edges **/

typedef struct node
{
  long ID;
  struct node *next;
}StackNode;

typedef StackNode *STACK_NODE_PTR;


/*****************************************************************************************
*
*  Declarations of procedures used in PointLocation
*
*****************************************************************************************/

float Log2(float x);
float CubeRoot(float x);
void GetKRandomEdges(long *iEdge, long k);
long ClosestEdgeFromQP(POINT_TYPE QP, long *iEdge, long size, POINT_TYPE *sFirstPoint);
void FindMidPoint( POINT_TYPE p1, POINT_TYPE p2, POINT_TYPE *midpoint );
void SetupGlobal(void* pPET[3], long aiNum[]);
bool EdgeIsOnBorder( EDGE_TYPE sEdge );
long GetTriangleContainingEdge(long AnEdge, long TheTri );
void FindEdge_UpdatePoint(long iTri, STACK_NODE_PTR *spEdgeIDs,
			  POINT_TYPE *sFirstPoint, POINT_TYPE sLastPoint);
void StackPush( STACK_NODE_PTR *topPtr, long id );
void StackPop( STACK_NODE_PTR *topPtr, long *id );
void StackPrint( STACK_NODE_PTR currentPtr );
void GET_POINT( long PointId, POINT_TYPE *Point );
void GET_EDGE( long EdgeId, EDGE_TYPE *Edge );
void GET_TRIANGLE( long TriId, TRIANGLE_TYPE *Tri );
void Pause();
/*****************************************************************************************/


#endif
