
/* Sven,

	You have to pass the function Initialize_Ray(n, &arr) the level of recursion,
  n, and an array to hold the vertices of the triangles.  This should be a 3 by
  however big you need (depends upon the selected level of recursion).  Amr Elmasry
  setup the code for me after David Dobkin gave it to us.  The code is a bit
  cryptic but it worked right away with no problems.  Hope it is the same for you!

   Greg													3/3/98
				
************************************************************************************/
/* Dear Greg,
 Included is the code for the ray initialization stuff.
 To call it you have to use a call like
       Initialize_Ray(n,&arr)
  where n is the number of recursion steps.
        arr is the two dimensional array that will hold the vertices of the triangles.
      The declaration of them will be :
          int n;
          VERTEX_TYPE (*arr)[3].
  The above function is of integer type that returns the number of rays.
  Also donnot forget to free the array after using it.
                Amr. */
/**************************************************************/


typedef struct 
{
  float fx,fy,fz;
} VERTEX_TYPE;

#ifdef GASP
/* #include "../src/GASP_interface.h" */
#endif

#define END	-1
/*	Winged edge data structure represented in Lincoln file format


		\               /	 
		 \             /
		  \           /
		   \         /
	     e[0][0]\       /e[1][0]
		     \     /
		      \   /
			v[0]
			|
			|
			|
        f[0]		|e                 f[1]
			|
			|
			|
			|
			v[1]
                       / \
                      /   \
              e[0][1]/     \e[1][1]
                    /       \
                   /         \
                  /           \

*/

#ifndef Coord
#define Coord float
#endif

#ifndef NIL
#define NIL 0
#endif

#define BUFSIZE 256

typedef struct lvertex_t	{	
	Coord position[4];
	struct ledge_t *e;
	int order;
	} lvertex_t;

typedef struct ledge_t	{
	lvertex_t *v[2] ;
	struct lface_t   *f[2] ;
	struct ledge_t   *e[2][2] ;
	} ledge_t ;

struct facechars	{  
	union	{
		int color;	
		lvertex_t	*v;
		} cont ;
	};

typedef struct lface_t	{	
	Coord eqn[4];
	ledge_t *e;
	int order;
	struct facechars chars;			
	} lface_t ;

typedef struct ldata_t    { 
	char title[BUFSIZE]; 
	int dim, nvertices, nedges, nfaces, nobjects ;
	} ldata_t ;

typedef struct lincoln_t	{
	lvertex_t	*vlist;
	ledge_t		*elist;
	lface_t		*flist;
	ldata_t		data;
	} lincoln_t;

#define		Vint(v, orig) ( (int) ( v - orig) )

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define	TWOPI	6.28318530717958647688

char    * myalloc( int n);
void my_free(char *cpt)	;
void make_vertex(lvertex_t *v, float px, float py, float pz, float pw, ledge_t *e, int ord);
void make_edge(ledge_t *e, lvertex_t *v0,lvertex_t *v1, lface_t *f0,lface_t *f1, ledge_t *e00,ledge_t *e01,ledge_t *e10,ledge_t *e11);
void make_face(lface_t *f, float ex, float ey, float ez, float ew, ledge_t *e, int ord);

void icosahedron_setup( lincoln_t	*lin );
lvertex_t * icos_ver(int i, int j);
ledge_t *icos_edg( int i, int j, int l);
lface_t *icos_fac( int j, int l);
int  refine(lincoln_t *lin, int rec_lvls, lincoln_t lout, VERTEX_TYPE (**arr)[3]);
void refine_align_data( lincoln_t *lin, lincoln_t *lout);
void refine_allocate( lincoln_t *lout, int r, ldata_t inf);
void divide_edge( ledge_t *e, lvertex_t *newv, ledge_t *newe);
void reverse_edge_vertex( ledge_t *e );
void align_face( int i, ledge_t *e, lface_t *f);
void reverse_edge_face( ledge_t *e);
void divide_face(lface_t *f, ledge_t *enew, lface_t *fnew);
void add_to_queue( ledge_t *e );
void locate( Coord *p0, Coord *p1, Coord *pmid);
int Initialize_Ray_Stack(int nlvls, VERTEX_TYPE (**Parr)[3]);


char    * myalloc( int     n) 
{
        static char *mret ;
        char *cptr;

        mret = (char *) malloc((unsigned) n);
        if (mret == NULL)       {
                fprintf(stderr," out of memory cannot allocate %d bytes\n",n);
                exit(12);
                }

        for (cptr = mret ; cptr < mret + n ; cptr++ )
                *cptr = 0 ;

        return(mret);
}

void my_free(char *cpt)	{
        if (cpt != NULL)
                free(cpt);
        else fprintf(stderr," freeing nil pointer, hope that's ok\n");
}

void make_vertex(lvertex_t *v, float px, float py, float pz, float pw, ledge_t *e, int ord) {	
	v->position[0] = px;
	v->position[1] = py;
	v->position[2] = pz;
	v->position[3] = pw;
	v->e = e;
	v->order = ord;
}

void make_edge(ledge_t *e, lvertex_t *v0,lvertex_t *v1, lface_t *f0,lface_t *f1, 
	ledge_t *e00,ledge_t *e01,ledge_t *e10,ledge_t *e11)	{
	e->v[0]  = v0  ;
	e->v[1]  = v1  ;
	e->f[0]  = f0  ;
	e->f[1]  = f1  ;
	e->e[0][0] = e00 ;
	e->e[0][1] = e01 ;
	e->e[1][0] = e10 ;
	e->e[1][1] = e11 ;
}

void make_face(lface_t *f, float ex, float ey, float ez, float ew,
	ledge_t *e, int ord)	{
	f->eqn[0] = ex;
	f->eqn[1] = ey;
	f->eqn[2] = ez;
	f->eqn[3] = ew;
	f->e = e;
	f->order = ord;
}

static lvertex_t *vof,*voff;
static ledge_t *eof,*eoff[4];
static lface_t *fof,*foff[3];

lvertex_t *vo;
ledge_t *eo;
lface_t *fo;

void icosahedron_setup( lincoln_t	*lin ) 		{
	int i,j;
	double r;

#define RADIUS  .85065080835203916072
#define TOPOINT .92230732857981734716
#define TOTOP   .52573111211913146166

	lin->data.nvertices  =  12 ;
	lin->data.nfaces     =  20 ;
	lin->data.nedges     =  30 ;
	lin->data.nobjects   = 0;
	lin->data.dim        = 3;

	lin->vlist = (lvertex_t *) 
			myalloc(lin->data.nvertices * sizeof(lvertex_t) );

	lin->elist = (ledge_t *) 
			myalloc(lin->data.nedges * sizeof(ledge_t) );

	lin->flist = (lface_t *) 
			myalloc(lin->data.nfaces * sizeof(lface_t) );

        vo = lin->vlist;
        eo = lin->elist;
        fo = lin->flist;

	vof = vo;
	voff = vof + 1;
	eof = eo;
	eoff[0] = eof+5; 
	eoff[1] = eoff[0]+10 ; 
	eoff[2] = eoff[1]+5; 
	eoff[3] = eoff[2] + 5;
	fof = fo;
	foff[0] = fof + 5 ; 
	foff[1] = foff[0] +  5 ;
	foff[2] = foff[1] + 5; 


/* filling in the ends of the vertex list	*/

	make_vertex(vof, 0., 0., -RADIUS/2 + -TOTOP ,  1., eof, 5);
	make_vertex(vof+11, 0., 0., RADIUS/2 + TOTOP  ,  1., eoff[3], 5);

	for (j = 0; j < 5; j++ )	{

/* filling in fields for the vertices */
		for (i = 0; i < 2; i++)	
			make_vertex(icos_ver(i,j), 
				RADIUS*sin(i*TWOPI/10.+j*TWOPI/5.),
				RADIUS*cos(i*TWOPI/10. + j*TWOPI/5.), 
				(i-.5)*RADIUS, 1.,icos_edg(i,j,0),5);

/* filling in fields for the edges */

/*below*/	make_edge(icos_edg(0,j,-1), vof,icos_ver(0,j), icos_fac(j-1,-1),
			icos_fac(j,-1), icos_edg(0,j-1,-1), icos_edg(0,j-1,0), 
			icos_edg(0,j+1,-1),icos_edg(0,j,0));
/* l = 0 */	
/* i = 0 */	make_edge(icos_edg(0,j,0), icos_ver(0,j), icos_ver(0,j+1),
			icos_fac(j,-1), icos_fac(j,0), icos_edg(0,j,-1),
			icos_edg(0,j+1,-1), icos_edg(0,j,2), icos_edg(0,j,1));
/* i = 1 */	make_edge(icos_edg(1,j,0), icos_ver(1,j), icos_ver(1,j+1), 
			foff[2] + j, icos_fac(j,1), icos_edg(0,j,3),
			icos_edg(0,j+1,3), icos_edg(0,j,1), icos_edg(0,j+1,2));

/* i is only 0 for the remaining cases of edges */

/* l = 1  */	make_edge(icos_edg(0,j,1),icos_ver(1,j),icos_ver(0,j+1),
			icos_fac(j,0), icos_fac(j,1), icos_edg(0,j,2),
			icos_edg(0,j,0), icos_edg(1,j,0), icos_edg(0,j+1,2));

/* l = 2  */	make_edge(icos_edg(0,j,2), icos_ver(1,j), icos_ver(0,j),
			icos_fac(j,0), icos_fac(j-1,1), icos_edg(0,j,1),
			icos_edg(0,j,0), icos_edg(1,j-1,0), icos_edg(0,j-1,1));

/*above*/	make_edge(icos_edg(0,j,3), vof+11, icos_ver(1,j), 
			icos_fac(j-1,2),icos_fac(j,2), icos_edg(0,j-1,3), 
			icos_edg(1,j-1,0), icos_edg(0,j+1,3),icos_edg(1,j,0));

/* filling in fields for the faces */

/* below  */	make_face(icos_fac(j,-1),0.,0.,0.,0.,icos_edg(0,j,-1),3);
/* l = 0  */	make_face(icos_fac(j,0),0.,0.,0.,0.,icos_edg(0,j,0),3);
/* l = 1  */	make_face(icos_fac(j,1),0.,0.,0.,0.,icos_edg(1,j,0),3);
/* above  */	make_face(icos_fac(j,2),0.,0.,0.,0.,icos_edg(0,j,3),3);
			}

	for (i = 0 ; i < 12 ; i++ )	{
		Coord	*cp;
		cp = lin->vlist[i].position;
		r = sqrt(cp[0]*cp[0] + cp[1]*cp[1] + cp[2]*cp[2] );
		for (j = 0 ; j < 3 ; j++ )
			cp[j] /= r;
		}
}

lvertex_t * icos_ver(int i, int j)	{
	i = (i+2)%2;	j = (j+5)%5;	return (voff + i*5 + j); }

ledge_t *icos_edg( int i, int j, int l)	{
	switch(l) { 
		case  0 : i = (i+2)%2; break; 
		case -1: i = -1; l = 0; break; 
		default : i = 0 ;  /* case 2 3 */
		}
	return (eoff[l] + i*5 + (j+5)%5 ); 
}

lface_t *icos_fac( int j, int l)
{	return (((l == -1) ? (foff[0] + (j+5)%5 - 5) : (foff[l] + (j+5)%5)));}


#define MAXRECUR 2

struct queuemember {
		struct queuemember *nextq;	
		ledge_t *qename; 
		} ;

struct wholequeue { 
		int size; 
		struct queuemember *qfirst,*qfinal; 
		} q;

/* this is a manipulation of an object,
pass an object to this routine and a 
new object is returned which is a refinement
of you original object
*/

int refine(lincoln_t *lin, int rec_lvls, lincoln_t lout,VERTEX_TYPE (**arr)[3]) 	{
	ledge_t  *eo , *newe, *etmp;
	lface_t *ftmp, *ftmp2;
	lvertex_t *newv;
	struct queuemember *qmem;
	int i, ic, rr, *recur, recursion_levels = MAXRECUR;
	ldata_t used ;
        /* VERTEX_TYPE (*tmp)[3]; */
	

	recursion_levels = rec_lvls;

	refine_allocate(&lout,recursion_levels, lin->data );
	recur = (int *) myalloc(lout.data.nedges * sizeof(int) );
	for (i = 0; i < lout.data.nedges ; i++ )	
		recur[i] = 0;

	refine_align_data(lin,&lout) ;

	used.nvertices = lin->data.nvertices;;
	used.nedges = lin->data.nedges;
	used.nfaces = lin->data.nfaces;

	q.size = 0;
	if (recursion_levels > 0)
		for (eo = lout.elist, i = 0 ; i < lin->data.nedges; i++, eo++ )
			add_to_queue(eo); 

	while (q.size != 0) {
		qmem = q.qfirst;
		newe = lout.elist+used.nedges++ ;
		newv = lout.vlist+used.nvertices++ ;
		divide_edge(qmem->qename,newv,newe);
		recur[newe - lout.elist] = ++recur[qmem->qename - lout.elist];
		if (recur[newe-lout.elist] < recursion_levels) {
			add_to_queue(qmem->qename); 
			add_to_queue(newe); 
			}

		for (ftmp = qmem->qename->f[0], ic = 0 ; ic < 2 ; 
				ftmp = qmem->qename->f[1] , ic++ ) 
			if (ftmp)
				if ((++ftmp->order) == 6) {
					etmp = lout.elist + used.nedges;
					ftmp2 = lout.flist+used.nfaces ;
 					rr = recur[ftmp->e - lout.elist];
					divide_face(ftmp,etmp,ftmp2);
					for (i = 0 ; i < 3 ; i++ )
						recur[etmp+i - lout.elist] = rr;
					if (rr < recursion_levels)
						for (i = 0 ; i < 3 ; i++ )
							add_to_queue(etmp+i);
					used.nedges += 3;
					used.nfaces += 3;
					}

		if (q.size-- > 1) 
			q.qfirst = qmem->nextq;
		my_free((char *) qmem);	
		}
{
#define N_NEW(l, n1,t, name)   l = (t*)calloc((n1),sizeof(t));
#define N_NEW1(l, n1, v)  l = calloc ((n1), sizeof(* v));

float (*points)[3] ;
int i,j, vno, fno, *indices,p[3] ;
lface_t	*b;
ledge_t *e;
lvertex_t *v;

N_NEW1(points, lout.data.nvertices, points);
N_NEW1(*arr,lout.data.nfaces,*arr);

/* points = (float *) myalloc(lout.data.nvertices * 3 * sizeof(float) );  */
  for (i = 0 ; i < lout.data.nvertices ; i++){
    points[i][0] = lout.vlist[i].position[0] ;
    points[i][1] = lout.vlist[i].position[1] ;
    points[i][2] = lout.vlist[i].position[2] ;
  }
indices = (int *) myalloc(lout.data.nfaces * 4 * sizeof(int) );
  for (i = 0 ; i < lout.data.nfaces ; i++){
	b = &lout.flist[i];

        e = b->e;
        v = e->v[0];
        p[0] = Vint(v, lout.vlist );
        for ( j = 1; j< 3 ; j++) {
                vno = (e->v[0] == v) ? 1 : 0;
                fno = (e->f[0] == b ) ? 0 : 1;
                v = e->v[vno];
                e = e->e[fno][vno];
                p[j] = Vint(v,lout.vlist );
                }

		
    indices[i*4]   = p[0];
    indices[i*4+1] = p[1];
    indices[i*4+2] = p[2];
    indices[i*4+3] = END;
  }

#ifdef GASP
  GASP_Begin_atomic("The Mesh");
 GASP_Create_mesh("mesh0", lout.data.nvertices, lout.data.nfaces*4, points, indices);
  GASP_End_atomic();
#else
	/* printf(" %d %d \n",lout.data.nvertices ,lout.data.nfaces );
	for (i = 0 ; i < lout.data.nvertices ; i++)
		printf(" %g %g %g \n",points[i][0], points[i][1], points[i][2]); 
  	for (i = 0 ; i < lout.data.nfaces ; i++)
		printf("3 %d %d %d\n",indices[4*i], indices[4*i+1], 
			indices[4*i+2]); */
        for (i=0 ; i <lout.data.nfaces ; i++)  {
                (*arr)[i][0].fx = points[indices[4*i]][0];
                (*arr)[i][0].fy = points[indices[4*i]][1];
                (*arr)[i][0].fz = points[indices[4*i]][2];
                (*arr)[i][1].fx = points[indices[4*i+1]][0];
                (*arr)[i][1].fy = points[indices[4*i+1]][1];
                (*arr)[i][1].fz = points[indices[4*i+1]][2];
                (*arr)[i][2].fx = points[indices[4*i+2]][0];
                (*arr)[i][2].fy = points[indices[4*i+2]][1];
                (*arr)[i][2].fz = points[indices[4*i+2]][2];
             }
         
         return(lout.data.nfaces);
                 
#endif
}


}

void refine_align_data( lincoln_t *lin, lincoln_t *lout)	{
	int i;
	lvertex_t *vin, *vout, *vi, *vo ;
	ledge_t   *ein, *eout, *ei, *eo ;
	lface_t   *fin, *fout, *fi, *fo ;

	vout = vo = lout->vlist ; 
	vin = vi = lin->vlist ;
	eout = eo = lout->elist ; 
	ein = ei = lin->elist ;
	fout = fo = lout->flist ;
	fin = fi = lin->flist ;

	for ( i = 0 ; i < lin->data.nvertices ; i++ ,  vin++ , vout++ )	{
		*vout = *vin;
		vout->e = (vout->e - ei) + eo;
		}

	for ( i = 0 ; i < lin->data.nedges ; i++ , ein++ , eout++)	{
		*eout = *ein;
		eout->v[0]  = (eout->v[0] - vi) + vo;
		eout->v[1]  = (eout->v[1] - vi) + vo;
		eout->e[0][0] = (eout->e[0][0] - ei) + eo;
		eout->e[0][1] = (eout->e[0][1] - ei) + eo;
		eout->e[1][0] = (eout->e[1][0] - ei) + eo;
		eout->e[1][1] = (eout->e[1][1] - ei) + eo;
		eout->f[0] = (eout->f[0] - fi) + fo;
		eout->f[1] = (eout->f[1] - fi) + fo;
		}

	for ( i = 0 ; i < lin->data.nfaces ; i++ , fout++ , fin++)	{
		*fout = *fin;
		fout->e = (fout->e - ei) + eo;
		}
}

void refine_allocate( lincoln_t *lout, int r, ldata_t inf) 	{
	int twor, fourr ;

/*	number of vertices, edges and faces at rewcursion level r are

	v(r) = v(r-1) + e(r-1)
	e(r) = 2*e(r-1) + 3*f(r-1)
	f(r) = 4*f(r-1)
or
	v(r) = ( (4^r)/2 + 1 - (3/2)*(2^r)) f(0) + (2^r -1) e(0) + v(0)
	e(r) = 3/2 * (4^r - 2^r) f(0) + 2^r e(0)
	f(r) = 4^r f(0)

*/
	twor = (int) pow( 2.  , (double) (r));
	fourr = (int) pow( 4.  , (double) (r));

	lout->data.nvertices  =  ((fourr - 3*twor)/2 +1) * inf.nfaces ;
	lout->data.nvertices +=  (twor - 1) * inf.nedges + inf.nvertices ;
	lout->data.nfaces     = fourr * inf.nfaces;
	lout->data.nedges     = 3./2. * (fourr - twor) * inf.nfaces ;
	lout->data.nedges    += twor * inf.nedges ;
	lout->data.nobjects   = 0;
	lout->data.dim        = 3;

	lout->vlist = (lvertex_t *) 
			myalloc(lout->data.nvertices * sizeof(lvertex_t) );

	lout->elist = (ledge_t *) 
			myalloc(lout->data.nedges * sizeof(ledge_t) );

	lout->flist = (lface_t *) 
			myalloc(lout->data.nfaces * sizeof(lface_t) );

}

void divide_edge( ledge_t *e, lvertex_t *newv, ledge_t *newe) 	{

/* find coordinates of midpoint (possibly perturbing)	*/
	locate(e->v[0]->position,e->v[1]->position,newv->position);

	newv->e = newe; newv->order = 2;	/* vertex fields	*/
	newe->v[0] = newv; newe->v[1] = e->v[1]; e->v[1] = newv; 
	newe->f[0] = e->f[0]; newe->f[1] = e->f[1]; /* edge fields		*/

	if (e->f[1]) {
		if (newe->e[1][1] = e->e[1][1] ) {
			if (e == newe->e[1][1]->e[0][0])  newe->e[1][1]->e[0][0] = newe; 
			else if (e == newe->e[1][1]->e[0][1])  newe->e[1][1]->e[0][1] = 
newe; 
			else if (e == newe->e[1][1]->e[1][0])  newe->e[1][1]->e[1][0] = 
newe; 
			else if (e == newe->e[1][1]->e[1][1])  newe->e[1][1]->e[1][1] = 
newe; 
			else {
				fprintf(stderr,"bad exit divide-edge face1\n");
				exit(1);
				}
			}
		newe->e[1][0] = e; 
		e->e[1][1] = newe;
		}

	if (e->f[0])	{
		if (newe->e[0][1] = e->e[0][1] ) {
			if (e == newe->e[0][1]->e[0][0])  newe->e[0][1]->e[0][0] = newe;
			else if (e == newe->e[0][1]->e[0][1])  newe->e[0][1]->e[0][1] = 
newe; 
			else if (e == newe->e[0][1]->e[1][0])  newe->e[0][1]->e[1][0] = 
newe; 
			else if (e == newe->e[0][1]->e[1][1])  newe->e[0][1]->e[1][1] = 
newe; 
			else 	{
				fprintf(stderr,"bad exit divide-edge face0\n");
				exit(1);
				}
			}
		newe->e[0][0] = e; 
		e->e[0][1] = newe;
		}

}

void reverse_edge_vertex( ledge_t *e ) 	{
	ledge_t *etmp;
	lvertex_t *vtmp;
	vtmp  = e->v[0] ; e->v[0]  = e->v[1] ; e->v[1]  = vtmp;
	etmp  = e->e[0][0]; e->e[0][0] = e->e[0][1]; e->e[0][1] = etmp;	
	etmp  = e->e[1][0]; e->e[1][0] = e->e[1][1]; e->e[1][1] = etmp;	
}

void align_face( int i, ledge_t *e, lface_t *f) 	{
	switch (i)	{

	case 1 : if (e->f[1] != f) 
			if (e->f[0] != f) {
				fprintf(stderr,"bad topology \n");
				exit(2345);
				}
			else reverse_edge_face(e);
		break;

	case 0 : if (e->f[0] != f) 
			if (e->f[1] != f) {
				fprintf(stderr,"bad topology \n");
				exit(2345);
				}
			else reverse_edge_face(e);
		break;
	default : fprintf(stderr,"bad argument to align_face \n");
	}
}

void reverse_edge_face( ledge_t *e)	{
	ledge_t *etmp;
	lface_t *ftmp;
	ftmp  = e->f[0] ; e->f[0]  = e->f[1] ; e->f[1]  = ftmp;
	etmp  = e->e[0][0]; e->e[0][0] = e->e[1][0]; e->e[1][0] = etmp;	
	etmp  = e->e[0][1]; e->e[0][1] = e->e[1][1]; e->e[1][1] = etmp;	
}

void divide_face(lface_t *f, ledge_t *enew, lface_t *fnew)	{
	lvertex_t *vhex[6], *vtmp, *minv ;
	ledge_t *ehex[6], *etmp ;
	int i, mini, i1 , i2 , twoi , twoi1 ;

/* trace the edges and vertices of the hexagon	to be subdivided
do this in such a way that ehex[i]->v[0] is vhex[i] and ehex[i]->v[1] is vhex[i+1].
Also, assure that ehex[i]->f[0] is f
*/
	ehex[0] = f->e;
	vhex[0] = ehex[0]->v[0];
	align_face(0,ehex[0],f);
	for (i = 1; i < 6; i++) {
		vhex[i] = ehex[i-1]->v[1];
		ehex[i] = ehex[i-1]->e[0][1] ;
		if (vhex[i] == ehex[i]->v[1])	
			reverse_edge_vertex(ehex[i]);
		align_face(0,ehex[i],f);
		}

/* test to make sure we are doing the correct triangle	
We assume that the triangle we want to do does not include
the vertex of lowest number.  This is true because the 3
vertices of the triangle (to be created) were added by
divide_edges adding vertices of higher numbers 
*/

	minv = vhex[0]; mini = 0;
	for (i = 1 ; i < 6 ; i++ )
		if (vhex[i] < minv)	{
			mini = i; 
			minv = vhex[i];
			}
	if ((mini%2) == 1) {
		etmp = ehex[0]; vtmp = vhex[0];
		for (i = 0 ; i < 5 ; i++ )	{
			ehex[i] = ehex[i+1];
			vhex[i] = vhex[i+1];
			}
		ehex[5] = etmp; vhex[5] = vtmp;
		}


/* fill in the edge and face parameters	and update vertices	*/
	f->e = enew; 
	f->order = 3 ;
	for (i = 0 ; i < 3 ; i++ )	{
		i1 = (i + 1)%3;
		i2 = (i + 2)%3;
		twoi = i+i;
		twoi1 = i1 + i1;

		make_edge(enew+i,vhex[5-twoi],vhex[5-twoi1],f,fnew+i,
			enew+i2,enew+i1,ehex[4-twoi],ehex[(9-twoi)%6]);
		ehex[4-twoi]->e[0][1] = enew + i; 
		ehex[4-twoi]->f[0] = fnew + i;
		ehex[(9-twoi)%6]->e[0][0] = enew + i; 
		ehex[(9-twoi)%6]->f[0] = fnew + i;

		make_face(fnew + i , 0., 0., 0., 0. , enew + i , 3);
		vhex[2*i + 1]->order += 2;
		}
}

void add_to_queue( ledge_t *e )	{
	struct queuemember *qmem;
	
	qmem = (struct queuemember *) myalloc(sizeof (struct queuemember) );
	qmem->qename = e;
	if (q.size == 0) { 
		q.qfirst = qmem; 
		q.qfinal = qmem;
		}
	else 	{ 
		q.qfinal->nextq = qmem; 
		q.qfinal = qmem;
		}
	qmem->nextq = NIL;
	q.size++;
}

void locate( Coord *p0, Coord *p1, Coord *pmid)		{
	int	i;
	double	r;
	for (i = 0 ; i < 3 ; i++ )
		pmid[i] = (p0[i] + p1[i])/2.;
	r = sqrt(pmid[0]*pmid[0] + pmid[1]*pmid[1] + pmid[2]*pmid[2] );
	for (i = 0 ; i < 3 ; i++ )
		pmid[i] /= r;
}

int Initialize_Ray(int nlvls, VERTEX_TYPE (**Parr)[3])	
{

	lincoln_t	lin, lout;
        int icount;
	
	if (nlvls < 1) 		nlvls = 1;
	if (nlvls > 10) 	nlvls = 10;

#ifdef GASP
  GASP_Init("hier_style_file", 1);
  GASP_Begin_atomic("OPEN");
  GASP_Change_msg_size(512);
  GASP_Open_view("VIEW", "Hierarchies", 300, 300, 1250, 990);
  GASP_End_atomic("OPEN");
 
  GASP_Begin_atomic("Scaling");
  GASP_Scale_world();
  GASP_End_atomic();
#endif
	icosahedron_setup(&lin);
	icount=refine(&lin,nlvls,lout,Parr);
        return(icount);
}

/********************************************************/


